Index: src/atom.hpp
===================================================================
--- src/atom.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -28,8 +28,10 @@
 #include "atom_trajectoryparticle.hpp"
 #include "tesselation.hpp"
+#include "types.hpp"
 
 /****************************************** forward declarations *****************************/
 
 class Vector;
+class World;
 
 /********************************************** declarations *******************************/
@@ -39,4 +41,6 @@
  */
 class atom : public TesselPoint, public TrajectoryParticle, public GraphNode, public BondedParticle, public virtual ParticleInfo, public virtual AtomInfo {
+  friend atom* NewAtom(atomId_t);
+  friend void  DeleteAtom(atom*);
   public:
     atom *previous; //!< previous atom in molecule list
@@ -45,7 +49,5 @@
     int *sort;      //!< sort criteria
 
-  atom();
-  atom(class atom *pointer);
-  virtual ~atom();
+  virtual atom *clone();
 
   bool OutputIndexed(ofstream * const out, const int ElementNo, const int AtomNo, const char *comment = NULL) const;
@@ -67,6 +69,61 @@
   bool IsInParallelepiped(const Vector offset, const double *parallelepiped) const;
 
+  // getter and setter
+
+  /**
+   * returns the World that contains this atom.
+   * Use this if you need to get the world without locking
+   * the singleton for example.
+   *
+   */
+  World *getWorld();
+  void setWorld(World*);
+
+  virtual atomId_t getId();
+  virtual bool changeId(atomId_t newId);
+
+  /**
+   * this function sets the Id without notifying the world. Only use it, if the world has already
+   * gotten an ID for this Atom.
+   */
+   virtual void setId(atomId_t);
+
+  protected:
+    /**
+     * Protected constructor to ensure construction of atoms through the world.
+     * see World::createAtom()
+     */
+    atom();
+
+    /**
+     * Protected copy-constructor to ensure construction of atoms by cloning.
+     * see atom::clone()
+     */
+    atom(class atom *pointer);
+
+    /**
+     * Protected destructor to ensure destruction of atoms through the world.
+     * see World::destroyAtom()
+     */
+    virtual ~atom();
   private:
+    World* world;
+    atomId_t id;
 };
 
+/**
+ * internal method used by the world. Do not use if you don't know what you are doing.
+ * You might get burned...
+ * Use World::createAtom() instead.
+ */
+atom* NewAtom(atomId_t _id);
+
+/**
+* internal method used by the world. Do not use if you don't know what you are doing.
+ * You might get burned...
+ * Use World::destroyAtom() instead.
+ */
+void  DeleteAtom(atom*);
+
+
 #endif /* ATOM_HPP_ */
Index: src/atom_atominfo.cpp
===================================================================
--- src/atom_atominfo.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_atominfo.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -6,4 +6,6 @@
  */
 
+#include "periodentafel.hpp"
+#include "World.hpp"
 #include "atom_atominfo.hpp"
 
@@ -18,2 +20,14 @@
 };
 
+const element *AtomInfo::getType(){
+  return type;
+}
+
+void AtomInfo::setType(const element* _type) {
+  type = _type;
+}
+
+void AtomInfo::setType(int Z) {
+  const element *elem = World::getInstance().getPeriode()->FindElement(Z);
+  setType(elem);
+}
Index: src/atom_atominfo.hpp
===================================================================
--- src/atom_atominfo.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_atominfo.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -32,8 +32,12 @@
   Vector v;       //!< velocity vector of atom, giving last velocity within cell
   Vector F;       //!< Force vector of atom, giving last force within cell
-  element *type;  //!< pointing to element
+  const element *type;  //!< pointing to element
 
   AtomInfo();
   ~AtomInfo();
+
+  const element *getType();
+  void setType(const element *);
+  void setType(int);
 
 private:
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_bondedparticle.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -44,11 +44,11 @@
 void BondedParticle::OutputBondOfAtom() const
 {
-  Log() << Verbose(4) << "Atom " << Name << "/" << nr << " with " << ListOfBonds.size() << " bonds: " << endl;
+  DoLog(4) && (Log() << Verbose(4) << "Atom " << Name << "/" << nr << " with " << ListOfBonds.size() << " bonds: " << endl);
   int TotalDegree = 0;
   for (BondList::const_iterator Runner = ListOfBonds.begin(); Runner != ListOfBonds.end(); ++Runner) {
-    Log() << Verbose(4) << **Runner << endl;
+    DoLog(4) && (Log() << Verbose(4) << **Runner << endl);
     TotalDegree += (*Runner)->BondDegree;
   }
-  Log() << Verbose(4) << " -- TotalDegree: " << TotalDegree << endl;
+  DoLog(4) && (Log() << Verbose(4) << " -- TotalDegree: " << TotalDegree << endl);
 };
 
@@ -75,4 +75,20 @@
 };
 
+/**
+ * Adds a bond between this bonded particle and another. Does nothing if this
+ * bond already exists.
+ *
+ * \param bonding partner
+ */
+void BondedParticle::addBond(BondedParticle* Partner) {
+  if (IsBondedTo(Partner)) {
+    return;
+  }
+
+  bond* newBond = new bond((atom*) this, (atom*) Partner, 1, 0);
+  RegisterBond(newBond);
+  Partner->RegisterBond(newBond);
+}
+
 /** Puts a given bond into atom::ListOfBonds.
  * \param *Binder bond to insert
@@ -86,8 +102,8 @@
       status = true;
     } else {
-      eLog() << Verbose(1) << *Binder << " does not contain " << *this << "." << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << *Binder << " does not contain " << *this << "." << endl);
     }
   } else {
-    eLog() << Verbose(1) << "Binder is " << Binder << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Binder is " << Binder << "." << endl);
   }
   return status;
@@ -105,8 +121,8 @@
       status = true;
     } else {
-      eLog() << Verbose(1) << *Binder << " does not contain " << *this << "." << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << *Binder << " does not contain " << *this << "." << endl);
     }
   } else {
-    eLog() << Verbose(1) << "Binder is " << Binder << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Binder is " << Binder << "." << endl);
   }
   return status;
@@ -150,5 +166,5 @@
       //Log() << Verbose(2) << "Increased bond degree for bond " << *CandidateBond << "." << endl;
     } else {
-      eLog() << Verbose(2) << "Could not find correct degree for atom " << *this << "." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Could not find correct degree for atom " << *this << "." << endl);
       FalseBondDegree++;
     }
Index: src/atom_bondedparticle.hpp
===================================================================
--- src/atom_bondedparticle.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_bondedparticle.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -37,4 +37,5 @@
   virtual ~BondedParticle();
 
+  void addBond(BondedParticle* Partner);
   bool RegisterBond(bond *Binder);
   bool UnregisterBond(bond *Binder);
Index: src/atom_graphnode.cpp
===================================================================
--- src/atom_graphnode.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_graphnode.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -27,7 +27,7 @@
 void GraphNode::OutputGraphInfo() const
 {
-  Log() << Verbose(2) << "Atom " << Name << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ";
+  DoLog(2) && (Log() << Verbose(2) << "Atom " << Name << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ");
   OutputComponentNumber();
-  Log() << Verbose(3) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl;
+  DoLog(3) && (Log() << Verbose(3) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl);
 };
 
@@ -40,5 +40,5 @@
   if (ComponentNr != NULL) {
     for (int i=0; ComponentNr[i] != -1; i++)
-      Log() << Verbose(2) << ComponentNr[i] << " ";
+      DoLog(2) && (Log() << Verbose(2) << ComponentNr[i] << " ");
   }
 };
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_particleinfo.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -13,4 +13,13 @@
 ParticleInfo::ParticleInfo() : nr(-1), Name(NULL) {};
 
+ParticleInfo::ParticleInfo(ParticleInfo *pointer) :
+    nr(pointer->nr),
+    Name(pointer->Name)
+    {
+      if (Name == NULL)
+        Name = " ";
+    }
+
+
 /** Destructor of ParticleInfo.
  */
@@ -20,11 +29,10 @@
 };
 
-int ParticleInfo::getId() {
-  return nr;
-}
-
 ostream & operator << (ostream &ost, const ParticleInfo &a)
 {
-  ost << "[" << a.Name << "|" << &a << "]";
+  if (a.Name == NULL)
+    ost << "[NULL]";
+  else
+    ost << "[" << a.Name << "|" << &a << "]";
   return ost;
 };
@@ -32,5 +40,8 @@
 ostream & ParticleInfo::operator << (ostream &ost) const
 {
-  ost << "[" << Name << "|" << this << "]";
+  if (Name == NULL)
+    ost << "[NULL]";
+  else
+    ost << "[" << Name << "|" << this << "]";
   return ost;
 };
Index: src/atom_particleinfo.hpp
===================================================================
--- src/atom_particleinfo.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_particleinfo.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -31,9 +31,8 @@
 
   ParticleInfo();
+  ParticleInfo(ParticleInfo*);
   ~ParticleInfo();
 
   ostream & operator << (ostream &ost) const;
-
-  virtual int getId();
 
 private:
Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom_trajectoryparticle.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -34,5 +34,5 @@
 {
   for (int i=NDIM;i--;)
-    *temperature += type->mass * Trajectory.U.at(step).x[i]* Trajectory.U.at(step).x[i];
+    *temperature += type->mass * Trajectory.U.at(step)[i]* Trajectory.U.at(step)[i];
 };
 
@@ -49,5 +49,5 @@
   // set forces
   for (int i=NDIM;i++;)
-    Force->Matrix[0][nr][5+i] += 2.*constant*sqrt(Trajectory.R.at(startstep).Distance(&Sprinter->Trajectory.R.at(endstep)));
+    Force->Matrix[0][nr][5+i] += 2.*constant*sqrt(Trajectory.R.at(startstep).distance(Sprinter->Trajectory.R.at(endstep)));
 };
 
@@ -60,6 +60,6 @@
 {
   for(int d=0;d<NDIM;d++) {
-    Trajectory.U.at(Step).x[d] -= CoGVelocity->x[d];
-    *ActualTemp += 0.5 * type->mass * Trajectory.U.at(Step).x[d] * Trajectory.U.at(Step).x[d];
+    Trajectory.U.at(Step)[d] -= CoGVelocity->at(d);
+    *ActualTemp += 0.5 * type->mass * Trajectory.U.at(Step)[d] * Trajectory.U.at(Step)[d];
   }
 };
@@ -89,7 +89,7 @@
 
   for (int n=NDIM;n--;) {
-    Trajectory.R.at(dest).x[n] = Trajectory.R.at(src).x[n];
-    Trajectory.U.at(dest).x[n] = Trajectory.U.at(src).x[n];
-    Trajectory.F.at(dest).x[n] = Trajectory.F.at(src).x[n];
+    Trajectory.R.at(dest)[n] = Trajectory.R.at(src)[n];
+    Trajectory.U.at(dest)[n] = Trajectory.U.at(src)[n];
+    Trajectory.F.at(dest)[n] = Trajectory.F.at(src)[n];
   }
 };
@@ -105,13 +105,13 @@
   //a = configuration.Deltat*0.5/walker->type->mass;        // (F+F_old)/2m = a and thus: v = (F+F_old)/2m * t = (F + F_old) * a
   for (int d=0; d<NDIM; d++) {
-    Trajectory.F.at(NextStep).x[d] = -Force->Matrix[0][nr][d+5]*(configuration->GetIsAngstroem() ? AtomicLengthToAngstroem : 1.);
-    Trajectory.R.at(NextStep).x[d] = Trajectory.R.at(NextStep-1).x[d];
-    Trajectory.R.at(NextStep).x[d] += configuration->Deltat*(Trajectory.U.at(NextStep-1).x[d]);     // s(t) = s(0) + v * deltat + 1/2 a * deltat^2
-    Trajectory.R.at(NextStep).x[d] += 0.5*configuration->Deltat*configuration->Deltat*(Trajectory.F.at(NextStep).x[d]/type->mass);     // F = m * a and s =
+    Trajectory.F.at(NextStep)[d] = -Force->Matrix[0][nr][d+5]*(configuration->GetIsAngstroem() ? AtomicLengthToAngstroem : 1.);
+    Trajectory.R.at(NextStep)[d] = Trajectory.R.at(NextStep-1)[d];
+    Trajectory.R.at(NextStep)[d] += configuration->Deltat*(Trajectory.U.at(NextStep-1)[d]);     // s(t) = s(0) + v * deltat + 1/2 a * deltat^2
+    Trajectory.R.at(NextStep)[d] += 0.5*configuration->Deltat*configuration->Deltat*(Trajectory.F.at(NextStep)[d]/type->mass);     // F = m * a and s =
   }
   // Update U
   for (int d=0; d<NDIM; d++) {
-    Trajectory.U.at(NextStep).x[d] = Trajectory.U.at(NextStep-1).x[d];
-    Trajectory.U.at(NextStep).x[d] += configuration->Deltat * (Trajectory.F.at(NextStep).x[d]+Trajectory.F.at(NextStep-1).x[d]/type->mass); // v = F/m * t
+    Trajectory.U.at(NextStep)[d] = Trajectory.U.at(NextStep-1)[d];
+    Trajectory.U.at(NextStep)[d] += configuration->Deltat * (Trajectory.F.at(NextStep)[d]+Trajectory.F.at(NextStep-1)[d]/type->mass); // v = F/m * t
   }
   // Update R (and F)
@@ -134,5 +134,5 @@
   *TotalMass += type->mass;  // sum up total mass
   for(int d=0;d<NDIM;d++) {
-    TotalVelocity->x[d] += Trajectory.U.at(Step).x[d]*type->mass;
+    TotalVelocity->at(d) += Trajectory.U.at(Step)[d]*type->mass;
   }
 };
@@ -145,5 +145,5 @@
 void TrajectoryParticle::Thermostat_Woodcock(double ScaleTempFactor, int Step, double *ekin)
 {
-  double *U = Trajectory.U.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
@@ -160,6 +160,6 @@
 void TrajectoryParticle::Thermostat_Gaussian_init(int Step, double *G, double *E)
 {
-  double *U = Trajectory.U.at(Step).x;
-  double *F = Trajectory.F.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
+  Vector &F = Trajectory.F.at(Step);
   if (FixedIon == 0) // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
@@ -177,5 +177,5 @@
 void TrajectoryParticle::Thermostat_Gaussian_least_constraint(int Step, double G_over_E, double *ekin, config *configuration)
 {
-  double *U = Trajectory.U.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
@@ -194,14 +194,14 @@
 {
   double sigma  = sqrt(configuration->TargetTemp/type->mass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
-  double *U = Trajectory.U.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     // throw a dice to determine whether it gets hit by a heat bath particle
     if (((((rand()/(double)RAND_MAX))*configuration->TempFrequency) < 1.)) {
-      Log() << Verbose(3) << "Particle " << *this << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ";
+      DoLog(3) && (Log() << Verbose(3) << "Particle " << *this << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ");
       // pick three random numbers from a Boltzmann distribution around the desired temperature T for each momenta axis
       for (int d=0; d<NDIM; d++) {
         U[d] = gsl_ran_gaussian (r, sigma);
       }
-      Log() << Verbose(2) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl;
+      DoLog(2) && (Log() << Verbose(2) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl);
     }
     for (int d=0; d<NDIM; d++)
@@ -218,5 +218,5 @@
 void TrajectoryParticle::Thermostat_Berendsen(int Step, double ScaleTempFactor, double *ekin, config *configuration)
 {
-  double *U = Trajectory.U.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
@@ -233,5 +233,5 @@
 void TrajectoryParticle::Thermostat_NoseHoover_init(int Step, double *delta_alpha)
 {
-  double *U = Trajectory.U.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
@@ -248,5 +248,5 @@
 void TrajectoryParticle::Thermostat_NoseHoover_scale(int Step, double *ekin, config *configuration)
 {
-  double *U = Trajectory.U.at(Step).x;
+  Vector &U = Trajectory.U.at(Step);
   if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
     for (int d=0; d<NDIM; d++) {
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/bond.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,5 +15,7 @@
 /** Empty Constructor for class bond.
  */
-bond::bond() : leftatom(NULL), rightatom(NULL), previous(NULL), next(NULL), HydrogenBond(0), BondDegree(0), nr(-1), Cyclic(false), Type(Undetermined), Used(white)
+bond::bond()
+  : leftatom(NULL), rightatom(NULL), previous(NULL), next(NULL), HydrogenBond(0),
+    BondDegree(0), nr(-1), Cyclic(false), Type(Undetermined), Used(white)
 {
 };
@@ -25,5 +27,7 @@
  * \param number increasing index
  */
-bond::bond(atom *left, atom *right, const int degree, const int number) : leftatom(left), rightatom(right), previous(NULL), next(NULL), HydrogenBond(0), BondDegree(degree), nr(number), Cyclic(false), Type(Undetermined), Used(white)
+bond::bond(atom *left, atom *right, const int degree, const int number)
+  : leftatom(left), rightatom(right), previous(NULL), next(NULL), HydrogenBond(0),
+    BondDegree(degree), nr(number), Cyclic(false), Type(Undetermined), Used(white)
 {
   if ((left != NULL) && (right != NULL)) {
@@ -63,5 +67,5 @@
   if(rightatom == Atom) 
     return leftatom;
-  eLog() << Verbose(1) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl;
+  DoeLog(1) && (eLog()<< Verbose(1) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl);
   return NULL;
 };
@@ -99,5 +103,5 @@
 bool bond::MarkUsed(const enum Shading color) {
   if (Used == black) {
-    eLog() << Verbose(1) << "Bond " << this << " was already marked black!." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Bond " << this << " was already marked black!." << endl);
     return false;
   } else {
@@ -119,5 +123,5 @@
 double bond::GetDistance() const
 {
-  return (leftatom->node->Distance(rightatom->node));
+  return (leftatom->node->distance(*rightatom->node));
 };
 
@@ -127,4 +131,4 @@
 double bond::GetDistanceSquared() const
 {
-  return (leftatom->node->DistanceSquared(rightatom->node));
+  return (leftatom->node->DistanceSquared(*rightatom->node));
 };
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/bondgraph.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,4 +9,5 @@
 
 #include "atom.hpp"
+#include "bond.hpp"
 #include "bondgraph.hpp"
 #include "element.hpp"
@@ -49,5 +50,5 @@
   // allocate MatrixContainer
   if (BondLengthMatrix != NULL) {
-    Log() << Verbose(1) << "MatrixContainer for Bond length already present, removing." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "MatrixContainer for Bond length already present, removing." << endl);
     delete(BondLengthMatrix);
   }
@@ -55,8 +56,8 @@
 
   // parse in matrix
-  if (status = TempContainer->ParseMatrix(filename.c_str(), 0, 1, 0)) {
-    Log() << Verbose(1) << "Parsing bond length matrix successful." << endl;
+  if ((status = TempContainer->ParseMatrix(filename.c_str(), 0, 1, 0))) {
+    DoLog(1) && (Log() << Verbose(1) << "Parsing bond length matrix successful." << endl);
   } else {
-    eLog() << Verbose(1) << "Parsing bond length matrix failed." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Parsing bond length matrix failed." << endl);
   }
 
@@ -86,5 +87,6 @@
 bool BondGraph::ConstructBondGraph(molecule * const mol)
 {
-  bool status = true;
+  Info FunctionInfo(__func__);
+bool status = true;
 
   if (mol->start->next == mol->end) // only construct if molecule is not empty
@@ -119,4 +121,5 @@
 double BondGraph::SetMaxDistanceToMaxOfCovalentRadii(const molecule * const mol)
 {
+  Info FunctionInfo(__func__);
   max_distance = 0.;
 
@@ -159,5 +162,5 @@
 {
   if (BondLengthMatrix == NULL) {// safety measure if no matrix has been parsed yet
-    eLog() << Verbose(2) << "BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl);
     CovalentMinMaxDistance(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
   } else {
@@ -168,3 +171,2 @@
   }
 };
-
Index: src/bondgraph.hpp
===================================================================
--- src/bondgraph.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/bondgraph.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -19,4 +19,8 @@
 
 #include <iostream>
+
+/*********************************************** defines ***********************************/
+
+#define BONDTHRESHOLD 0.4   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii
 
 /****************************************** forward declarations *****************************/
